#ifndef BUILDERQUAD_H
#define BUILDERQUAD_H

#include "builder.h"

class BuilderQuad : public Builder
{
	public:

		virtual void build(VertexVector & vertices, TriangleVector & triangles) const
		{
			vertices.resize(4);

			vertices[0].position [0] = -1.0f;
			vertices[0].position [1] = -1.0f;
			vertices[0].position [2] =  0.0f;
			vertices[0].normal   [0] =  0.0f;
			vertices[0].normal   [1] =  0.0f;
			vertices[0].normal   [2] =  1.0f;
			vertices[0].texcoord [0] =  0.0f;
			vertices[0].texcoord [1] =  0.0f;
			vertices[0].color    [0] =   255;
			vertices[0].color    [1] =     0;
			vertices[0].color    [2] =     0;
			vertices[0].color    [3] =   255;

			vertices[1].position [0] =  1.0f;
			vertices[1].position [1] = -1.0f;
			vertices[1].position [2] =  0.0f;
			vertices[1].normal   [0] =  0.0f;
			vertices[1].normal   [1] =  0.0f;
			vertices[1].normal   [2] =  1.0f;
			vertices[1].texcoord [0] =  1.0f;
			vertices[1].texcoord [1] =  0.0f;
			vertices[1].color    [0] =     0;
			vertices[1].color    [1] =   255;
			vertices[1].color    [2] =     0;
			vertices[1].color    [3] =   255;

			vertices[2].position [0] = -1.0f;
			vertices[2].position [1] =  1.0f;
			vertices[2].position [2] =  0.0f;
			vertices[2].normal   [0] =  0.0f;
			vertices[2].normal   [1] =  0.0f;
			vertices[2].normal   [2] =  1.0f;
			vertices[2].texcoord [0] =  0.0f;
			vertices[2].texcoord [1] =  1.0f;
			vertices[2].color    [0] =     0;
			vertices[2].color    [1] =     0;
			vertices[2].color    [2] =   255;
			vertices[2].color    [3] =   255;

			vertices[3].position [0] =  1.0f;
			vertices[3].position [1] =  1.0f;
			vertices[3].position [2] =  0.0f;
			vertices[3].normal   [0] =  0.0f;
			vertices[3].normal   [1] =  0.0f;
			vertices[3].normal   [2] =  1.0f;
			vertices[3].texcoord [0] =  1.0f;
			vertices[3].texcoord [1] =  1.0f;
			vertices[3].color    [0] =   255;
			vertices[3].color    [1] =     0;
			vertices[3].color    [2] =   255;
			vertices[3].color    [3] =   255;

			triangles.resize(2);

			triangles[0].vertices[0] = 0;
			triangles[0].vertices[1] = 1;
			triangles[0].vertices[2] = 2;

			triangles[1].vertices[0] = 2;
			triangles[1].vertices[1] = 1;
			triangles[1].vertices[2] = 3;
		}
};

#endif // BUILDERQUAD_H
