#ifndef MESHVERTEXARRAY_H
#define MESHVERTEXARRAY_H

#include "mesh.h"
#include "fw.h"

class MeshVertexArray : public Mesh
{
	public:

		virtual void render(void) const
		{
			if (this->vertices.empty() || this->triangles.empty()) return;

			const GLsizei stride = sizeof(Vertex);
			const unsigned char * base = reinterpret_cast<const unsigned char *>(&(this->vertices[0]));

			glVertexPointer   (3, GL_FLOAT,         stride, base + VERTEX_FIELD_BYTE_OFFSET(position));
			glNormalPointer   (   GL_FLOAT,         stride, base + VERTEX_FIELD_BYTE_OFFSET(normal)  );
			glTexCoordPointer (2, GL_FLOAT,         stride, base + VERTEX_FIELD_BYTE_OFFSET(texcoord));
			glColorPointer    (4, GL_UNSIGNED_BYTE, stride, base + VERTEX_FIELD_BYTE_OFFSET(color)   );

			glEnableClientState(GL_VERTEX_ARRAY       );
			glEnableClientState(GL_NORMAL_ARRAY       );
			glEnableClientState(GL_TEXTURE_COORD_ARRAY);
			glEnableClientState(GL_COLOR_ARRAY        );

			glDrawElements(GL_TRIANGLES, this->triangles.size() * 3, GL_UNSIGNED_INT, &(this->triangles[0].vertices));

			glDisableClientState(GL_VERTEX_ARRAY       );
			glDisableClientState(GL_NORMAL_ARRAY       );
			glDisableClientState(GL_TEXTURE_COORD_ARRAY);
			glDisableClientState(GL_COLOR_ARRAY        );
		}
};

#endif // MESHVERTEXARRAY_H
