#include "types.h"
#include "fw.h"

MT::Mesh     gMesh;
MT::Builder  gBuilder;
MT::Updater  gUpdater;
MT::Renderer gRenderer;

void initialize(void)
{
	gRenderer.initialize();
	gMesh.create(gBuilder);
}

void finalize(void)
{
	gRenderer.finalize();
	gMesh.destroy();
}

void update(float dt)
{
	gRenderer.update(dt);
	gMesh.update(gUpdater, dt);
}

void draw(int width, int height)
{
	glClearColor(0.5f, 0.5f, 0.5f, 0.0f);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);

	glViewport(0, 0, width, height);

	gRenderer.beginRender(width, height);
		gRenderer.render(gMesh);
	gRenderer.endRender();
}
